Versionsverlauf
===============

## [Noch nicht veröffentlicht]

- derzeit keine Änderungen

## [Version 2.2.0] - 2020-10-26

### Neu

#### Einschränkung von Jobnummern

Die von der KEXTls vergebenen Jobnummern für Telegramme liegen gemäß TLS zwischen 1 und 255.
  
Für die KRI-2X/KRI-2b in NRW ist es erforderlich, dass jeder Client nur einen bestimmten (anpassbaren) Jobnummernbereich verwendet. 
Soll ein individueller Jobnummernbereich eingestellt werden, können die notwendigen Parameter über folgende Einträge bei der 
`atg.protokollEinstellungenStandard` des Anschlusspunkts für alle Verbindungen an diesem Anschlusspunkt eingestellt werden:

Name = `osi7.jobNummerMinimal`
Wert = 1–255, Defaultwert ist 1

Name = `osi7.jobNummerMaximal`
Wert = 1–255, Defaultwert ist 255

**WICHTIG**: Damit dieses Feature genutzt werden kann, müssen die folgenden SWE jeweils in mindestens der angegebenen Version verwendet werden:

- `de.bsvrz.kex.tls.osi2osi3` ab Version 3.10.0 
- `de.bsvrz.kex.tls.osi7` ab Version 5.8.0 


Setzt den Featurewunsch [Einschränkung von Jobnummern - #12](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/-/issues/12) um. 


## [Version 2.1.3]

- Polling im Client ersetzt, um die erzeugte CPU-Last zu verringern
- Behebt den Fehler [Fehler 2](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi2osi3.osi2.tlsoip/issues/2)

## Version 2.1.2

- NERZ: Umstellung auf Gradle, Build durch FTB und Bereitstellung auf NERZ-Repositories

## Version 2.1.1

- Stand 01.12.2015 

### Zeitoptimierung Timer im Client
  - Änderungen nach Vorgabe BitCtrl, Gieseler


## Version 2.1.0

- Stand 22.07.2014

### Fragmentierte Telegramme beim Empfang

Folgendes Problem wurden behoben:

- Die TLS-Over-IP-Implementierung wirft manchmal eine Exception, die in Folge dann auch 
zur Terminierung der TLS-Over-IP-Verbindung führt.

Hier der Stacktrace:

```java
FEHLER : KEx-TLS.de.bsvrz.kex.tls.osi2osi3.osi2.tlsoip.Client
Länge des Datenblocks laut Header (60) kleiner als vorhandene Anzahl der Nutzdaten (36):
     de.bsvrz.kex.tls.osi2osi3.osi2.tlsoip.Client$IllegalTelegramException: Länge des Datenblocks laut Header (60) kleiner als vorhandene Anzahl der Nutzdaten (36)
       at de.bsvrz.kex.tls.osi2osi3.osi2.tlsoip.Client$Link.handleSelection(Client.java:1194)
       at de.bsvrz.kex.tls.osi2osi3.osi2.tlsoip.Client$Worker.run(Client.java:1534)
       at java.lang.Thread.run(Thread.java:744)
```

Ursache für die Exception ist die Tatsache, dass ein Telegramm auf dem Weg vom Sender zum Empfänger
so zerstückelt werden kann, dass es in zwei Teilen beim Empfänger ankommen kann. Die bisherige
Implementierung wirft in diesem Fall eine Exception und terminiert die Verbindung.

TCP gibt keinerlei Garantien für den Erhalt von Blockgrenzen und eine TCP-Anwendung sollte damit
umgehen können, wenn Telegramme zerstückelt werden.

Die Implementierung wurde so geändert, das teilweise empfangene Telegramm im `_readBuffer` belassen werden
und ganz normal (ohne zusätzliche Timeouts) auf den Empfang von weiteren Daten gewartet wird. Wenn dann
weitere Daten kommen wird der Header des Telegramms erneut aus dem `_readBuffer` gelesen und erneut geprüft,
ob das Telegramm vollständig ist.

## Version 2.0.0

- Stand 06.04.2012 

### Erste Veröffentlichte Version
- Freigegeben in NI.
- Einsatz u.a. in NI (seit 10.2011) und BW

[Noch nicht veröffentlicht]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi2osi3.osi2.tlsoip/compare/v2.2.0...HEAD
[Version 2.2.0]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi2osi3.osi2.tlsoip/compare/v2.1.3...v2.2.0
[Version 2.1.3]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi2osi3.osi2.tlsoip/compare/v2.1.2...v2.1.3
